﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace TestProject
{
    public partial class GOLTest : Form
    {
        private int gridWidth = 30;
        private int gridHeight = 30;
        private int[,] gridArray = new int[500, 500];
        private int[,] startGrid = new int[500, 500];
        private int startWidth = 30;
        private int startHeight = 30;
        private int iterations;
        private Boolean quadLife = false;
        private Boolean gridWrap = false;
        private Boolean drawGrid = true;
        private int formWidth;
        private int formHeight;
        private int formTop;
        private int formLeft;
        private int totalAlive = 0;
        private int total1 = 0;
        private int total2 = 0;
        private int total3 = 0;
        private int total4 = 0;
        StatsBox statsbox = new StatsBox();

        public GOLTest()
        {
            InitializeComponent();
        }

        private void GOLTest_Load(object sender, EventArgs e)
        {
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }
        private void gridBox_Paint(object sender, PaintEventArgs e)
        {
            DateTime startTime = DateTime.Now;
            Graphics graph = e.Graphics;
            Pen gridPen = new Pen(Color.Black, 1);
            int cellWidth = panel2.Width / gridWidth;
            int cellHeight = panel2.Height / gridHeight;
            if (cellWidth == 0)
            {
                cellWidth = 1;
            }
            if (cellHeight == 0)
            {
                cellHeight = 1;
            }
           
            //Draw the cells
            int cellRow = 0;
            while (cellRow < gridHeight)
            {
                int cellCol = 0;
                while (cellCol < gridWidth)
                {
                    if (gridArray[cellCol, cellRow] == 1)
                    {
                        SolidBrush myBrush = new SolidBrush(Color.Red);
                        graph.FillRectangle(myBrush, new Rectangle((cellCol * cellWidth), (cellRow * cellHeight), (cellWidth), (cellHeight)));
                        myBrush.Dispose();
                    }
                    else if (gridArray[cellCol, cellRow] == 2)
                    {
                        SolidBrush myBrush = new SolidBrush(Color.Blue);
                        graph.FillRectangle(myBrush, new Rectangle((cellCol * cellWidth), (cellRow * cellHeight), (cellWidth), (cellHeight)));
                        myBrush.Dispose();
                    }
                    else if (gridArray[cellCol, cellRow] == 3)
                    {
                        SolidBrush myBrush = new SolidBrush(Color.Green);
                        graph.FillRectangle(myBrush, new Rectangle((cellCol * cellWidth), (cellRow * cellHeight), (cellWidth), (cellHeight)));
                        myBrush.Dispose();
                    }
                    else if (gridArray[cellCol, cellRow] == 4)
                    {
                        SolidBrush myBrush = new SolidBrush(Color.Yellow);
                        graph.FillRectangle(myBrush, new Rectangle((cellCol * cellWidth), (cellRow * cellHeight), (cellWidth), (cellHeight)));
                        myBrush.Dispose();
                    }
                    cellCol++;
                }
                cellRow++;
            }
            if (drawGrid == true)
            {

                //Draw the grid
                for (int i = 0; i <= gridWidth; i++)
                {
                    graph.DrawLine(gridPen, i * cellWidth, 0, i * cellWidth, gridBox.Height);
                }
                for (int i = 0; i <= gridBox.Height; i = i + cellHeight)
                {
                    graph.DrawLine(gridPen, 0, i, gridBox.Width, i);
                }

            }
            DateTime stopTime = DateTime.Now;
            TimeSpan duration = stopTime - startTime;
            toolStripStatusLabel5.Text = "Paint Time: " + duration.TotalMilliseconds + "ms";
        }

        private void gridBox_Resize(object sender, EventArgs e)
        {
            setBoxSize();
            gridBox.Refresh();
        }

        private void gridBox_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.X >= 1 && e.X <= gridBox.Width && e.Y >=1 && e.Y <= gridBox.Height)
            {
                //Establish the cell
                int cellWidth = gridBox.Width / gridWidth;
                int cellHeight = gridBox.Height / gridHeight;
                decimal xNo = e.X / cellWidth;
                decimal yNo = e.Y / cellHeight;
                int cellXno = (int)System.Math.Ceiling(xNo);
                int cellYno = (int)System.Math.Ceiling(yNo);

                if (quadRed.Enabled == false)
                {
                    gridArray[cellXno, cellYno] = 1;
                }
                if (quadBlue.Enabled == false)
                {
                    gridArray[cellXno, cellYno] = 2;
                }
                if (quadGreen.Enabled == false)
                {
                    gridArray[cellXno, cellYno] = 3;
                }
                if (quadYellow.Enabled == false)
                {
                    gridArray[cellXno, cellYno] = 4;
                }
                if (e.Button == MouseButtons.Right)
                {
                    gridArray[cellXno, cellYno] = 0;
                }
                gridBox.Refresh();
            }
        }

        private void x10ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            gridHeight = 10;
            gridWidth = 10;
            clearGrid();
            gridBox.Refresh();
            toolStripStatusLabel2.Text = "Grid Size: 10 x 10";
            x10ToolStripMenuItem.Checked = true;
            x20ToolStripMenuItem.Checked = false;
            x30ToolStripMenuItem.Checked = false;
            x40ToolStripMenuItem.Checked = false;
            x50ToolStripMenuItem.Checked = false;
            x60ToolStripMenuItem.Checked = false;
            x70ToolStripMenuItem.Checked = false;
            x80ToolStripMenuItem.Checked = false;
            x90ToolStripMenuItem.Checked = false;
            x100ToolStripMenuItem.Checked = false;
            x200ToolStripMenuItem.Checked = false;
            x300ToolStripMenuItem.Checked = false;
            x400ToolStripMenuItem.Checked = false;
            x500ToolStripMenuItem.Checked = false;
            setBoxSize();
        }

        private void x20ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            gridHeight = 20;
            gridWidth = 20;
            clearGrid();
            gridBox.Refresh();
            toolStripStatusLabel2.Text = "Grid Size: 20 x 20";
            x10ToolStripMenuItem.Checked = false;
            x20ToolStripMenuItem.Checked = true;
            x30ToolStripMenuItem.Checked = false;
            x40ToolStripMenuItem.Checked = false;
            x50ToolStripMenuItem.Checked = false;
            x60ToolStripMenuItem.Checked = false;
            x70ToolStripMenuItem.Checked = false;
            x80ToolStripMenuItem.Checked = false;
            x90ToolStripMenuItem.Checked = false;
            x100ToolStripMenuItem.Checked = false;
            x200ToolStripMenuItem.Checked = false;
            x300ToolStripMenuItem.Checked = false;
            x400ToolStripMenuItem.Checked = false;
            x500ToolStripMenuItem.Checked = false;
            setBoxSize();
        }

        private void x30ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            gridHeight = 30;
            gridWidth = 30;
            clearGrid();
            gridBox.Refresh();
            toolStripStatusLabel2.Text = "Grid Size: 30 x 30";
            x10ToolStripMenuItem.Checked = false;
            x20ToolStripMenuItem.Checked = false;
            x30ToolStripMenuItem.Checked = true;
            x40ToolStripMenuItem.Checked = false;
            x50ToolStripMenuItem.Checked = false;
            x60ToolStripMenuItem.Checked = false;
            x70ToolStripMenuItem.Checked = false;
            x80ToolStripMenuItem.Checked = false;
            x90ToolStripMenuItem.Checked = false;
            x100ToolStripMenuItem.Checked = false;
            x200ToolStripMenuItem.Checked = false;
            x300ToolStripMenuItem.Checked = false;
            x400ToolStripMenuItem.Checked = false;
            x500ToolStripMenuItem.Checked = false;
            setBoxSize();
        }

        private void x40ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            gridHeight = 40;
            gridWidth = 40;
            clearGrid();
            gridBox.Refresh();
            toolStripStatusLabel2.Text = "Grid Size: 40 x 40";
            x10ToolStripMenuItem.Checked = false;
            x20ToolStripMenuItem.Checked = false;
            x30ToolStripMenuItem.Checked = false;
            x40ToolStripMenuItem.Checked = true;
            x50ToolStripMenuItem.Checked = false;
            x60ToolStripMenuItem.Checked = false;
            x70ToolStripMenuItem.Checked = false;
            x80ToolStripMenuItem.Checked = false;
            x90ToolStripMenuItem.Checked = false;
            x100ToolStripMenuItem.Checked = false;
            x200ToolStripMenuItem.Checked = false;
            x300ToolStripMenuItem.Checked = false;
            x400ToolStripMenuItem.Checked = false;
            x500ToolStripMenuItem.Checked = false;
            setBoxSize();
            
        }

        private void x50ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            gridHeight = 50;
            gridWidth = 50;
            clearGrid();
            gridBox.Refresh();
            toolStripStatusLabel2.Text = "Grid Size: 50 x 50";
            x10ToolStripMenuItem.Checked = false;
            x20ToolStripMenuItem.Checked = false;
            x30ToolStripMenuItem.Checked = false;
            x40ToolStripMenuItem.Checked = false;
            x50ToolStripMenuItem.Checked = true;
            x60ToolStripMenuItem.Checked = false;
            x70ToolStripMenuItem.Checked = false;
            x80ToolStripMenuItem.Checked = false;
            x90ToolStripMenuItem.Checked = false;
            x100ToolStripMenuItem.Checked = false;
            x200ToolStripMenuItem.Checked = false;
            x300ToolStripMenuItem.Checked = false;
            x400ToolStripMenuItem.Checked = false;
            x500ToolStripMenuItem.Checked = false;
            setBoxSize();

        }

        private void toolStripMenuItem2_Click(object sender, EventArgs e)
        {
            if (toolStripMenuItem2.Checked == true)
            {
                toolStripMenuItem2.Checked = false;
                drawGrid = false;
                gridBox.Refresh();
            }
            else
            {
                toolStripMenuItem2.Checked = true;
                drawGrid = true;
                gridBox.Refresh();
            }
        }

        private void x60ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            gridHeight = 60;
            gridWidth = 60;
            clearGrid();
            gridBox.Refresh();
            toolStripStatusLabel2.Text = "Grid Size: 60 x 60";
            x10ToolStripMenuItem.Checked = false;
            x20ToolStripMenuItem.Checked = false;
            x30ToolStripMenuItem.Checked = false;
            x40ToolStripMenuItem.Checked = false;
            x50ToolStripMenuItem.Checked = false;
            x60ToolStripMenuItem.Checked = true;
            x70ToolStripMenuItem.Checked = false;
            x80ToolStripMenuItem.Checked = false;
            x90ToolStripMenuItem.Checked = false;
            x100ToolStripMenuItem.Checked = false;
            x200ToolStripMenuItem.Checked = false;
            x300ToolStripMenuItem.Checked = false;
            x400ToolStripMenuItem.Checked = false;
            x500ToolStripMenuItem.Checked = false;
            setBoxSize();

        }

        private void x70ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            gridHeight = 70;
            gridWidth = 70;
            clearGrid();
            gridBox.Refresh();
            toolStripStatusLabel2.Text = "Grid Size: 70 x 70";
            x10ToolStripMenuItem.Checked = false;
            x20ToolStripMenuItem.Checked = false;
            x30ToolStripMenuItem.Checked = false;
            x40ToolStripMenuItem.Checked = false;
            x50ToolStripMenuItem.Checked = false;
            x60ToolStripMenuItem.Checked = false;
            x70ToolStripMenuItem.Checked = true;
            x80ToolStripMenuItem.Checked = false;
            x90ToolStripMenuItem.Checked = false;
            x100ToolStripMenuItem.Checked = false;
            x200ToolStripMenuItem.Checked = false;
            x300ToolStripMenuItem.Checked = false;
            x400ToolStripMenuItem.Checked = false;
            x500ToolStripMenuItem.Checked = false;
            setBoxSize();
        }

        private void x80ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            gridHeight = 80;
            gridWidth = 80;
            clearGrid();
            gridBox.Refresh();
            toolStripStatusLabel2.Text = "Grid Size: 80 x 80";
            x10ToolStripMenuItem.Checked = false;
            x20ToolStripMenuItem.Checked = false;
            x30ToolStripMenuItem.Checked = false;
            x40ToolStripMenuItem.Checked = false;
            x50ToolStripMenuItem.Checked = false;
            x60ToolStripMenuItem.Checked = false;
            x70ToolStripMenuItem.Checked = false;
            x80ToolStripMenuItem.Checked = true;
            x90ToolStripMenuItem.Checked = false;
            x100ToolStripMenuItem.Checked = false;
            x200ToolStripMenuItem.Checked = false;
            x300ToolStripMenuItem.Checked = false;
            x400ToolStripMenuItem.Checked = false;
            x500ToolStripMenuItem.Checked = false;
            setBoxSize();
        }

        private void x90ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            gridHeight = 90;
            gridWidth = 90;
            clearGrid();
            gridBox.Refresh();
            toolStripStatusLabel2.Text = "Grid Size: 90 x 90";
            x10ToolStripMenuItem.Checked = false;
            x20ToolStripMenuItem.Checked = false;
            x30ToolStripMenuItem.Checked = false;
            x40ToolStripMenuItem.Checked = false;
            x50ToolStripMenuItem.Checked = false;
            x60ToolStripMenuItem.Checked = false;
            x70ToolStripMenuItem.Checked = false;
            x80ToolStripMenuItem.Checked = false;
            x90ToolStripMenuItem.Checked = true;
            x100ToolStripMenuItem.Checked = false;
            x200ToolStripMenuItem.Checked = false;
            x300ToolStripMenuItem.Checked = false;
            x400ToolStripMenuItem.Checked = false;
            x500ToolStripMenuItem.Checked = false;
            setBoxSize();
        }

        private void x100ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            gridHeight = 100;
            gridWidth = 100;
            clearGrid();
            gridBox.Refresh();
            toolStripStatusLabel2.Text = "Grid Size: 100 x 100";
            x10ToolStripMenuItem.Checked = false;
            x20ToolStripMenuItem.Checked = false;
            x30ToolStripMenuItem.Checked = false;
            x40ToolStripMenuItem.Checked = false;
            x50ToolStripMenuItem.Checked = false;
            x60ToolStripMenuItem.Checked = false;
            x70ToolStripMenuItem.Checked = false;
            x80ToolStripMenuItem.Checked = false;
            x90ToolStripMenuItem.Checked = false;
            x100ToolStripMenuItem.Checked = true;
            x200ToolStripMenuItem.Checked = false;
            x300ToolStripMenuItem.Checked = false;
            x400ToolStripMenuItem.Checked = false;
            x500ToolStripMenuItem.Checked = false;
            setBoxSize();
        }

        private void clearGrid()
        {
            for (int x = 0; x < 500; x++)
            {
                for (int y = 0; y < 500; y++)
                {
                    gridArray[x, y] = 0;
                }
            }
            totalAlive = 0;
            total1 = 0;
            total2 = 0;
            total3 = 0;
            total4 = 0;
            updateStats();
        }

        private void gridBox_MouseMove(object sender, MouseEventArgs e)
        {
            if (e.X >= 1 && e.X < gridBox.Width && e.Y >= 1 && e.Y < gridBox.Height && e.Button == System.Windows.Forms.MouseButtons.Left)
            {
                //Establish the cell
                int cellWidth = gridBox.Width / gridWidth;
                int cellHeight = gridBox.Height / gridHeight;
                double xNo = (e.X-1) / cellWidth;
                double yNo = (e.Y-1) / cellHeight;
                int cellXno = (int)System.Math.Ceiling(xNo);
                int cellYno = (int)System.Math.Ceiling(yNo);
                if (quadRed.Enabled == false)
                {
                    gridArray[cellXno, cellYno] = 1;
                }
                if (quadBlue.Enabled == false)
                {
                    gridArray[cellXno, cellYno] = 2;
                }
                if (quadGreen.Enabled == false)
                {
                    gridArray[cellXno, cellYno] = 3;
                }
                if (quadYellow.Enabled == false)
                {
                    gridArray[cellXno, cellYno] = 4;
                }
                gridBox.Refresh();
                updateStats();
            }
            if (e.X >= 1 && e.X < gridBox.Width && e.Y >= 1 && e.Y < gridBox.Height && e.Button == System.Windows.Forms.MouseButtons.Right)
            {
                //Establish the cell
                int cellWidth = gridBox.Width / gridWidth;
                int cellHeight = gridBox.Height / gridHeight;
                double xNo = (e.X - 1) / cellWidth;
                double yNo = (e.Y - 1) / cellHeight;
                int cellXno = (int)System.Math.Ceiling(xNo);
                int cellYno = (int)System.Math.Ceiling(yNo);
                gridArray[cellXno, cellYno] = 0;
                gridBox.Refresh();
                updateStats();
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            iterations = 0;
            timer1.Enabled = true;
            button1.Enabled = false;
            button2.Enabled = true;
            startWidth = gridWidth;
            startHeight = gridHeight;
            startGrid = gridArray;
            statsbox.resetstats();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            DateTime startTime = DateTime.Now;
            int[,] tempArray = new int[500, 500];
            totalAlive = 0;
            total1 = 0;
            total2 = 0;
            total3 = 0;
            total4 = 0;
            int cellCol = 0;
            while (cellCol < gridWidth)
            {
                int cellRow = 0;
                while (cellRow < gridHeight)
                {
                    int aliveCellCount = 0;
                    int cellType1 = 0;
                    int cellType2 = 0;
                    int cellType3 = 0;
                    int cellType4 = 0;
                    //check top left
                    if (cellRow - 1 >= 0 && cellCol - 1 >= 0)
                    {
                        if (gridArray[(cellRow - 1), (cellCol - 1)] == 1)
                        {
                            aliveCellCount++;
                            cellType1++;
                        }
                        if (gridArray[(cellRow - 1), (cellCol - 1)] == 2)
                        {
                            aliveCellCount++;
                            cellType2++;
                        }
                        if (gridArray[(cellRow - 1), (cellCol - 1)] == 3)
                        {
                            aliveCellCount++;
                            cellType3++;
                        }
                        if (gridArray[(cellRow - 1), (cellCol - 1)] == 4)
                        {
                            aliveCellCount++;
                            cellType4++;
                        }
                    }
                    else
                    {
                        if (gridWrap == true)
                        {
                            if (cellRow - 1 < 0 && cellCol - 1 >= 0)
                            {
                                //wrap left to right
                                if (gridArray[(gridWidth - 1), (cellCol - 1)] == 1)
                                {
                                    aliveCellCount++;
                                    cellType1++;
                                }
                                if (gridArray[(gridWidth - 1), (cellCol - 1)] == 2)
                                {
                                    aliveCellCount++;
                                    cellType2++;
                                }
                                if (gridArray[(gridWidth - 1), (cellCol - 1)] == 3)
                                {
                                    aliveCellCount++;
                                    cellType3++;
                                }
                                if (gridArray[(gridWidth - 1), (cellCol - 1)] == 4)
                                {
                                    aliveCellCount++;
                                    cellType4++;
                                }
                            }
                            if (cellRow - 1 >= 0 && cellCol - 1 < 0)
                            {
                                //wrap top to bottom
                                if (gridArray[(cellRow - 1), (gridHeight - 1)] == 1)
                                {
                                    aliveCellCount++;
                                    cellType1++;
                                }
                                if (gridArray[(cellRow - 1), (gridHeight - 1)] == 2)
                                {
                                    aliveCellCount++;
                                    cellType2++;
                                }
                                if (gridArray[(cellRow - 1), (gridHeight - 1)] == 3)
                                {
                                    aliveCellCount++;
                                    cellType3++;
                                }
                                if (gridArray[(cellRow - 1), (gridHeight - 1)] == 4)
                                {
                                    aliveCellCount++;
                                    cellType4++;
                                }
                            }
                            if (cellRow - 1 < 0 && cellCol - 1 < 0)
                            {
                                //wrap top left to bottom right
                                if (gridArray[(gridWidth - 1), (gridHeight - 1)] == 1)
                                {
                                    aliveCellCount++;
                                    cellType1++;
                                }
                                if (gridArray[(gridWidth - 1), (gridHeight - 1)] == 2)
                                {
                                    aliveCellCount++;
                                    cellType2++;
                                }
                                if (gridArray[(gridWidth - 1), (gridHeight - 1)] == 3)
                                {
                                    aliveCellCount++;
                                    cellType3++;
                                }
                                if (gridArray[(gridWidth - 1), (gridHeight - 1)] == 4)
                                {
                                    aliveCellCount++;
                                    cellType4++;
                                }
                            }
                        }
                    }
                    //check left
                    if (cellCol - 1 >= 0)
                    {
                        if (gridArray[(cellRow), (cellCol - 1)] == 1)
                        {
                            aliveCellCount++;
                            cellType1++;
                        }
                        if (gridArray[(cellRow), (cellCol - 1)] == 2)
                        {
                            aliveCellCount++;
                            cellType2++;
                        }
                        if (gridArray[(cellRow), (cellCol - 1)] == 3)
                        {
                            aliveCellCount++;
                            cellType3++;
                        }
                        if (gridArray[(cellRow), (cellCol - 1)] == 4)
                        {
                            aliveCellCount++;
                            cellType4++;
                        }

                    }
                    else
                    {
                        if (gridWrap == true)
                        {
                            //wrap left to right
                            if (gridArray[(cellRow), (gridWidth - 1)] == 1)
                            {
                                aliveCellCount++;
                                cellType1++;
                            }
                            if (gridArray[(cellRow), (gridWidth - 1)] == 2)
                            {
                                aliveCellCount++;
                                cellType2++;
                            }
                            if (gridArray[(cellRow), (gridWidth - 1)] == 3)
                            {
                                aliveCellCount++;
                                cellType3++;
                            }
                            if (gridArray[(cellRow), (gridWidth - 1)] == 4)
                            {
                                aliveCellCount++;
                                cellType4++;
                            }
                        }
                    }
                    //check bottom left
                    if (cellRow + 1 < gridWidth && cellCol - 1 >= 0)
                    {
                        if (gridArray[(cellRow + 1), (cellCol - 1)] == 1)
                        {
                            aliveCellCount++;
                            cellType1++;
                        }
                        if (gridArray[(cellRow + 1), (cellCol - 1)] == 2)
                        {
                            aliveCellCount++;
                            cellType2++;
                        }
                        if (gridArray[(cellRow + 1), (cellCol - 1)] == 3)
                        {
                            aliveCellCount++;
                            cellType3++;
                        }
                        if (gridArray[(cellRow + 1), (cellCol - 1)] == 4)
                        {
                            aliveCellCount++;
                            cellType4++;
                        }
                    }
                    else
                    {
                        if (gridWrap == true)
                        {
                            if (cellRow + 1 >= gridWidth && cellCol - 1 >= 0)
                            {
                                //wrap left to right
                                if (gridArray[0, (cellCol - 1)] == 1)
                                {
                                    aliveCellCount++;
                                    cellType1++;
                                }
                                if (gridArray[0, (cellCol - 1)] == 2)
                                {
                                    aliveCellCount++;
                                    cellType2++;
                                }
                                if (gridArray[0, (cellCol - 1)] == 3)
                                {
                                    aliveCellCount++;
                                    cellType3++;
                                }
                                if (gridArray[0, (cellCol - 1)] == 4)
                                {
                                    aliveCellCount++;
                                    cellType4++;
                                }
                            }
                            if (cellRow + 1 < gridWidth && cellCol - 1 < 0)
                            {
                                //wrap bottom to top
                                if (gridArray[(cellRow + 1), (gridWidth - 1)] == 1)
                                {
                                    aliveCellCount++;
                                    cellType1++;
                                }
                                if (gridArray[(cellRow + 1), (gridWidth - 1)] == 2)
                                {
                                    aliveCellCount++;
                                    cellType2++;
                                }
                                if (gridArray[(cellRow + 1), (gridWidth - 1)] == 3)
                                {
                                    aliveCellCount++;
                                    cellType3++;
                                }
                                if (gridArray[(cellRow + 1), (gridWidth - 1)] == 4)
                                {
                                    aliveCellCount++;
                                    cellType4++;
                                }
                            }
                            if (cellRow + 1 < gridWidth && cellCol - 1 < 0)
                            {
                                //wrap bottom left to top right
                                if (gridArray[0, (gridWidth - 1)] == 1)
                                {
                                    aliveCellCount++;
                                    cellType1++;
                                }
                                if (gridArray[0, (gridWidth - 1)] == 2)
                                {
                                    aliveCellCount++;
                                    cellType2++;
                                }
                                if (gridArray[0, (gridWidth - 1)] == 3)
                                {
                                    aliveCellCount++;
                                    cellType3++;
                                }
                                if (gridArray[0, (gridWidth - 1)] == 4)
                                {
                                    aliveCellCount++;
                                    cellType4++;
                                }
                            }
                        }
                    }
                    //check top center
                    if (cellRow - 1 >= 0)
                    {
                        if (gridArray[(cellRow - 1), (cellCol)] == 1)
                        {
                            aliveCellCount++;
                            cellType1++;
                        }
                        if (gridArray[(cellRow - 1), (cellCol)] == 2)
                        {
                            aliveCellCount++;
                            cellType2++;
                        }
                        if (gridArray[(cellRow - 1), (cellCol)] == 3)
                        {
                            aliveCellCount++;
                            cellType3++;
                        }
                        if (gridArray[(cellRow - 1), (cellCol)] == 4)
                        {
                            aliveCellCount++;
                            cellType4++;
                        }
                    }
                    else
                    {
                        if (gridWrap == true)
                        {
                            //wrap top to bottom
                            if (gridArray[(gridHeight - 1), (cellCol)] == 1)
                            {
                                aliveCellCount++;
                                cellType1++;
                            }
                            if (gridArray[(gridHeight - 1), (cellCol)] == 2)
                            {
                                aliveCellCount++;
                                cellType2++;
                            }
                            if (gridArray[(gridHeight - 1), (cellCol)] == 3)
                            {
                                aliveCellCount++;
                                cellType3++;
                            }
                            if (gridArray[(gridHeight - 1), (cellCol)] == 4)
                            {
                                aliveCellCount++;
                                cellType4++;
                            }
                        }
                    }
                    //check bottom center
                    if (cellRow + 1 < gridWidth)
                    {
                        if (gridArray[(cellRow + 1), (cellCol)] == 1)
                        {
                            aliveCellCount++;
                            cellType1++;
                        }
                        if (gridArray[(cellRow + 1), (cellCol)] == 2)
                        {
                            aliveCellCount++;
                            cellType2++;
                        }
                        if (gridArray[(cellRow + 1), (cellCol)] == 3)
                        {
                            aliveCellCount++;
                            cellType3++;
                        }
                        if (gridArray[(cellRow + 1), (cellCol)] == 4)
                        {
                            aliveCellCount++;
                            cellType4++;
                        }
                    }
                    else
                    {
                        if (gridWrap == true)
                        {
                            //wrap bottom to top
                            if (gridArray[0, (cellCol)] == 1)
                            {
                                aliveCellCount++;
                                cellType1++;
                            }
                            if (gridArray[0, (cellCol)] == 2)
                            {
                                aliveCellCount++;
                                cellType2++;
                            }
                            if (gridArray[0, (cellCol)] == 3)
                            {
                                aliveCellCount++;
                                cellType3++;
                            }
                            if (gridArray[0, (cellCol)] == 4)
                            {
                                aliveCellCount++;
                                cellType4++;
                            }
                        }
                    }
                    //check top right
                    if (cellRow - 1 >= 0 && cellCol + 1 < gridHeight)
                    {
                        if (gridArray[(cellRow - 1), (cellCol + 1)] == 1)
                        {
                            aliveCellCount++;
                            cellType1++;
                        }
                        if (gridArray[(cellRow - 1), (cellCol + 1)] == 2)
                        {
                            aliveCellCount++;
                            cellType2++;
                        }
                        if (gridArray[(cellRow - 1), (cellCol + 1)] == 3)
                        {
                            aliveCellCount++;
                            cellType3++;
                        }
                        if (gridArray[(cellRow - 1), (cellCol + 1)] == 4)
                        {
                            aliveCellCount++;
                            cellType4++;
                        }
                    }
                    else
                    {
                        if (gridWrap == true)
                        {
                            if (cellRow - 1 < 0 && cellCol + 1 < gridHeight)
                            {
                                //wrap top to bottom
                                if (gridArray[(gridHeight - 1), (cellCol + 1)] == 1)
                                {
                                    aliveCellCount++;
                                    cellType1++;
                                }
                                if (gridArray[(gridHeight - 1), (cellCol + 1)] == 2)
                                {
                                    aliveCellCount++;
                                    cellType2++;
                                }
                                if (gridArray[(gridHeight - 1), (cellCol + 1)] == 3)
                                {
                                    aliveCellCount++;
                                    cellType3++;
                                }
                                if (gridArray[(gridHeight - 1), (cellCol + 1)] == 4)
                                {
                                    aliveCellCount++;
                                    cellType4++;
                                }
                            }
                            if (cellRow - 1 >= 0 && cellCol + 1 >= gridHeight)
                            {
                                //wrap right to left
                                if (gridArray[(cellRow - 1), 0] == 1)
                                {
                                    aliveCellCount++;
                                    cellType1++;
                                }
                                if (gridArray[(cellRow - 1), 0] == 2)
                                {
                                    aliveCellCount++;
                                    cellType2++;
                                }
                                if (gridArray[(cellRow - 1), 0] == 3)
                                {
                                    aliveCellCount++;
                                    cellType3++;
                                }
                                if (gridArray[(cellRow - 1), 0] == 4)
                                {
                                    aliveCellCount++;
                                    cellType4++;
                                }
                            }
                            if (cellRow - 1 < 0 && cellCol + 1 >= gridHeight)
                            {
                                //wrap top left to bottom right
                                if (gridArray[(gridHeight - 1), 0] == 1)
                                {
                                    aliveCellCount++;
                                    cellType1++;
                                }
                                if (gridArray[(gridHeight - 1), 0] == 2)
                                {
                                    aliveCellCount++;
                                    cellType2++;
                                }
                                if (gridArray[(gridHeight - 1), 0] == 3)
                                {
                                    aliveCellCount++;
                                    cellType3++;
                                }
                                if (gridArray[(gridHeight - 1), 0] == 4)
                                {
                                    aliveCellCount++;
                                    cellType4++;
                                }
                            }

                        }
                    }
                    //check right
                    if (cellCol + 1 < gridHeight)
                    {
                        if (gridArray[(cellRow), (cellCol + 1)] == 1)
                        {
                            aliveCellCount++;
                            cellType1++;
                        }
                        if (gridArray[(cellRow), (cellCol + 1)] == 2)
                        {
                            aliveCellCount++;
                            cellType2++;
                        }
                        if (gridArray[(cellRow), (cellCol + 1)] == 3)
                        {
                            aliveCellCount++;
                            cellType3++;
                        }
                        if (gridArray[(cellRow), (cellCol + 1)] == 4)
                        {
                            aliveCellCount++;
                            cellType4++;
                        }
                    }
                    else
                    {
                        if (gridWrap == true)
                        {
                            //wrap right to left
                            if (gridArray[(cellRow), 0] == 1)
                            {
                                aliveCellCount++;
                                cellType1++;
                            }
                            if (gridArray[(cellRow), 0] == 2)
                            {
                                aliveCellCount++;
                                cellType2++;
                            }
                            if (gridArray[(cellRow), 0] == 3)
                            {
                                aliveCellCount++;
                                cellType3++;
                            }
                            if (gridArray[(cellRow), 0] == 4)
                            {
                                aliveCellCount++;
                                cellType4++;
                            }
                        }
                    }
                    //check bottom right
                    if (cellRow + 1 < gridWidth && cellCol + 1 < gridHeight)
                    {
                        if (gridArray[(cellRow + 1), (cellCol + 1)] == 1)
                        {
                            aliveCellCount++;
                            cellType1++;
                        }
                        if (gridArray[(cellRow + 1), (cellCol + 1)] == 2)
                        {
                            aliveCellCount++;
                            cellType2++;
                        }
                        if (gridArray[(cellRow + 1), (cellCol + 1)] == 3)
                        {
                            aliveCellCount++;
                            cellType3++;
                        }
                        if (gridArray[(cellRow + 1), (cellCol + 1)] == 4)
                        {
                            aliveCellCount++;
                            cellType4++;
                        }
                    }
                    else
                    {
                        if (gridWrap == true)
                        {
                            if (cellRow + 1 >= gridWidth && cellCol + 1 < gridHeight)
                            {
                                //wrap bottom to top
                                if (gridArray[0, (cellCol + 1)] == 1)
                                {
                                    aliveCellCount++;
                                    cellType1++;
                                }
                                if (gridArray[0, (cellCol + 1)] == 2)
                                {
                                    aliveCellCount++;
                                    cellType2++;
                                }
                                if (gridArray[0, (cellCol + 1)] == 3)
                                {
                                    aliveCellCount++;
                                    cellType3++;
                                }
                                if (gridArray[0, (cellCol + 1)] == 4)
                                {
                                    aliveCellCount++;
                                    cellType4++;
                                }
                            }
                            if (cellRow + 1 < gridWidth && cellCol + 1 >= gridHeight)
                            {
                                //wrap right to left
                                if (gridArray[(cellRow + 1), 0] == 1)
                                {
                                    aliveCellCount++;
                                    cellType1++;
                                }
                                if (gridArray[(cellRow + 1), 0] == 2)
                                {
                                    aliveCellCount++;
                                    cellType2++;
                                }
                                if (gridArray[(cellRow + 1), 0] == 3)
                                {
                                    aliveCellCount++;
                                    cellType3++;
                                }
                                if (gridArray[(cellRow + 1), 0] == 4)
                                {
                                    aliveCellCount++;
                                    cellType4++;
                                }
                            }
                            if (cellRow + 1 >= gridWidth && cellCol + 1 >= gridHeight)
                            {
                                //wrap bottom right to top left
                                if (gridArray[0, 0] == 1)
                                {
                                    aliveCellCount++;
                                    cellType1++;
                                }
                                if (gridArray[0, 0] == 2)
                                {
                                    aliveCellCount++;
                                    cellType2++;
                                }
                                if (gridArray[0, 0] == 3)
                                {
                                    aliveCellCount++;
                                    cellType3++;
                                }
                                if (gridArray[0, 0] == 4)
                                {
                                    aliveCellCount++;
                                    cellType4++;
                                }
                            }
                        }
                    }

                    //check and apply the rules of life
                    if (gridArray[cellRow, cellCol] != 0)
                    {
                        if (aliveCellCount == 2 || aliveCellCount == 3)
                        {
                            totalAlive++;
                            int curVal = gridArray[cellRow, cellCol];
                            if (curVal == 1)
                            {
                                tempArray[cellRow, cellCol] = 1;
                                total1++;
                            }
                            else if (curVal == 2)
                            {
                                tempArray[cellRow, cellCol] = 2;
                                total2++;
                            }
                            else if (curVal == 3)
                            {
                                tempArray[cellRow, cellCol] = 3;
                                total3++;
                            }
                            else if (curVal == 4)
                            {
                                tempArray[cellRow, cellCol] = 4;
                                total4++;
                            }
                        }
                        else
                        {
                            tempArray[cellRow, cellCol] = 0;
                        }
                    }
                    else
                    {
                        if (aliveCellCount == 3)
                        {
                            totalAlive++;
                            if (quadLife == false)
                            {
                                //conways life rule
                                tempArray[cellRow, cellCol] = 1;
                            }
                            else
                            {
                                //quadlife rules
                                if (cellType1 > 1)
                                {
                                    tempArray[cellRow, cellCol] = 1;
                                    total1++;
                                }
                                else if (cellType2 > 1)
                                {
                                    tempArray[cellRow, cellCol] = 2;
                                    total2++;
                                }
                                else if (cellType3 > 1)
                                {
                                    tempArray[cellRow, cellCol] = 3;
                                    total3++;
                                }
                                else if (cellType4 > 1)
                                {
                                    tempArray[cellRow, cellCol] = 4;
                                    total4++;
                                }
                                else
                                {
                                    if (cellType1 == 0)
                                    {
                                        tempArray[cellRow, cellCol] = 1;
                                        total1++;
                                    }
                                    if (cellType2 == 0)
                                    {
                                        tempArray[cellRow, cellCol] = 2;
                                        total2++;
                                    }
                                    if (cellType3 == 0)
                                    {
                                        tempArray[cellRow, cellCol] = 3;
                                        total3++;
                                    }
                                    if (cellType4 == 0)
                                    {
                                        tempArray[cellRow, cellCol] = 4;
                                        total4++;
                                    }
                                }
                            }
                        }
                    }
                    cellRow++;
                }
                cellCol++;
            }
            gridArray = tempArray;
            gridBox.Refresh();
            iterations++;
            toolStripStatusLabel1.Text = "Iterations: " + iterations;
            updateStats();

            if (updateStats() == (gridHeight * gridWidth))
            {
                timer1.Enabled = false;
                button1.Enabled = true;
                button2.Enabled = false;
                MessageBox.Show("All of your cells are dead \nLife is over", "The End", System.Windows.Forms.MessageBoxButtons.OK);
            }
            DateTime stopTime = DateTime.Now;
            TimeSpan duration = stopTime - startTime;
            toolStripStatusLabel4.Text = "Logic Time: " + duration.TotalMilliseconds + "ms";
        }

        private void fillArrayRand()
        {
            Random randNo = new Random();
            int randMax = 2;
            if (quadLife == true)
            {
                randMax = 5;
            }
            for (int x = 0; x < gridWidth; x++)
            {
                for (int y = 0; y < gridHeight; y++)
                {
                    int cellVal = randNo.Next(0,(randMax*2));

                    if (cellVal >= randMax)
                    {
                        gridArray[x, y] = 0;
                    }
                    else
                    {
                        gridArray[x, y] = cellVal;
                    }
                }
            }
            gridBox.Refresh();
            updateStats();
        }

        private void randomiseToolStripMenuItem_Click(object sender, EventArgs e)
        {
            fillArrayRand();
        }
        
        private int updateStats()
        {
            int aliveCell = totalAlive;            
            int gridSize = gridHeight * gridWidth;
            int deadCell = gridSize - totalAlive;
            
            //display stats in the status bar
            deadStat.Text = "Dead: " + deadCell + "/" + gridSize;
            deadBar.Maximum = gridSize;
            deadBar.Value = deadCell;
            aliveStat.Text = "Alive: " + aliveCell + "/" + gridSize;
            aliveBar.Maximum = gridSize;
            aliveBar.Value = aliveCell;

            statsbox.statsUpdate(totalAlive,total1,total2,total3,total4, timer1.Enabled);
            return deadCell;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            button1.Enabled = true;
            button2.Enabled = false;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            button1.Enabled = true;
            button2.Enabled = false;
            clearGrid();
            gridBox.Refresh();
        }

        private void toolStripMenuItem3_Click(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            button1.Enabled = true;
            button2.Enabled = false;
            saveFileDialog.ShowDialog() ;
        }

        private void newRandomToolStripMenuItem_Click(object sender, EventArgs e)
        {
            fillArrayRand();
            iterations = 0;
            timer1.Enabled = true;
            button1.Enabled = false;
            button2.Enabled = true;
            startWidth = gridWidth;
            startHeight = gridHeight;
            startGrid = gridArray;
            statsbox.resetstats();
        }

        private void trackBar1_ValueChanged(object sender, EventArgs e)
        {
            timer1.Interval = 1010 - (trackBar1.Value * 100);
            toolStripStatusLabel3.Text = "Speed: " + trackBar1.Value;
        }

        private void quadLifeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            quadLife = true;
            quadLifeToolStripMenuItem.Checked = true;
            quadPanel.Visible = true;
            conwaysLifeToolStripMenuItem.Checked = false;
        }

        private void quadRed_Click(object sender, EventArgs e)
        {
            quadRed.Enabled = false;
            quadBlue.Enabled = true;
            quadGreen.Enabled = true;
            quadYellow.Enabled = true;
        }

        private void quadBlue_Click(object sender, EventArgs e)
        {
            quadRed.Enabled = true;
            quadBlue.Enabled = false;
            quadGreen.Enabled = true;
            quadYellow.Enabled = true;
        }

        private void quadGreen_Click(object sender, EventArgs e)
        {
            quadRed.Enabled = true;
            quadBlue.Enabled = true;
            quadGreen.Enabled = false;
            quadYellow.Enabled = true;
        }

        private void quadYellow_Click(object sender, EventArgs e)
        {
            quadRed.Enabled = true;
            quadBlue.Enabled = true;
            quadGreen.Enabled = true;
            quadYellow.Enabled = false;
        }

        private void conwaysLifeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            quadLife = false;
            quadLifeToolStripMenuItem.Checked = false;
            quadPanel.Visible = false;
            quadRed.Enabled = false;
            quadBlue.Enabled = true;
            quadGreen.Enabled = true;
            quadYellow.Enabled = true;
            conwaysLifeToolStripMenuItem.Checked = true;
        }

        private void loadToolStripMenuItem_Click(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            button1.Enabled = true;
            button2.Enabled = false;
            openFileDialog.ShowDialog();
        }

        private void openFileDialog_FileOk(object sender, CancelEventArgs e)
        {
            try
            {
                FileStream fileReader = new FileStream(openFileDialog.FileName,FileMode.Open, FileAccess.Read);
                StreamReader readstream = new StreamReader(fileReader);
                if (this.ProductVersion == readstream.ReadLine())
                {
                    int tempwidth;
                    int tempheight;
                    //returns 0 if failed
                    Int32.TryParse(readstream.ReadLine(), out tempwidth);
                    Int32.TryParse(readstream.ReadLine(), out tempheight);
                    //cause exception for dividing by 0
                    int checkwidth = tempwidth/tempwidth;
                    int checkheight = tempheight/tempheight;
                    //if it gets here it's ok
                    gridWidth = tempwidth;
                    gridHeight = tempheight;
                    for (int x = 0; x < gridWidth; x++)
                    {
                        char[] linearray = new char [100];
                        linearray = readstream.ReadLine().ToCharArray();
                        for (int y = 0; y < gridHeight; y++)
                        {
                            int cellvalue;
                            Int32.TryParse(""+linearray[y], out cellvalue);
                            gridArray[x, y] = cellvalue;
                        }
                    }
                }
                gridBox.Refresh();
                updateStats();
                
            }
            catch
            {
                MessageBox.Show("That didn't work", "Broken", System.Windows.Forms.MessageBoxButtons.OK);
                gridHeight = 30;
                gridWidth = 30;
                clearGrid();
                gridBox.Refresh();
                toolStripStatusLabel2.Text = "Grid Size: 30 x 30";
                x10ToolStripMenuItem.Checked = false;
                x20ToolStripMenuItem.Checked = false;
                x30ToolStripMenuItem.Checked = true;
                x40ToolStripMenuItem.Checked = false;
                x50ToolStripMenuItem.Checked = false;
                x60ToolStripMenuItem.Checked = false;
                x70ToolStripMenuItem.Checked = false;
                x80ToolStripMenuItem.Checked = false;
                x90ToolStripMenuItem.Checked = false;
                x100ToolStripMenuItem.Checked = false;
                Refresh();

            }
        }

        private void button4_Click(object sender, EventArgs e)
        {
            iterations = 0;
            timer1.Enabled = false;
            button1.Enabled = true;
            button2.Enabled = false;
            gridWidth = startWidth;
            gridHeight = startHeight;
            for (int x = 0; x < 500; x++)
            {
                for (int y = 0; y < 500; y++)
                {
                    gridArray[x,y] = startGrid[x,y];
                }
            }
            
            gridBox.Refresh();
        }

        private void saveFileDialog_FileOk(object sender, CancelEventArgs e)
        {
            FileStream fileSave = new FileStream(saveFileDialog.FileName,FileMode.Create, FileAccess.Write);
            StreamWriter stream = new StreamWriter(fileSave);
            stream.WriteLine(this.ProductVersion);
            stream.WriteLine(gridWidth);
            stream.WriteLine(gridHeight);
            String gridString = "";
            for (int x = 0; x < gridWidth; x++)
            {
                for (int y = 0; y < gridHeight; y++)
                {
                    gridString = gridString + gridArray[x, y];
                }
                stream.WriteLine(gridString);
                gridString = "";
            }
            


            stream.Close();
            stream.Dispose();
            fileSave.Dispose();

        }

        private void x200ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            gridHeight = 200;
            gridWidth = 200;
            clearGrid();
            gridBox.Refresh();
            toolStripStatusLabel2.Text = "Grid Size: 200 x 200";
            x10ToolStripMenuItem.Checked = false;
            x20ToolStripMenuItem.Checked = false;
            x30ToolStripMenuItem.Checked = false;
            x40ToolStripMenuItem.Checked = false;
            x50ToolStripMenuItem.Checked = false;
            x60ToolStripMenuItem.Checked = false;
            x70ToolStripMenuItem.Checked = false;
            x80ToolStripMenuItem.Checked = false;
            x90ToolStripMenuItem.Checked = false;
            x100ToolStripMenuItem.Checked = false;
            x200ToolStripMenuItem.Checked = true;
            x300ToolStripMenuItem.Checked = false;
            x400ToolStripMenuItem.Checked = false;
            x500ToolStripMenuItem.Checked = false;
            setBoxSize();
        }

        private void x300ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            gridHeight = 300;
            gridWidth = 300;
            clearGrid();
            gridBox.Refresh();
            toolStripStatusLabel2.Text = "Grid Size: 300 x 300";
            x10ToolStripMenuItem.Checked = false;
            x20ToolStripMenuItem.Checked = false;
            x30ToolStripMenuItem.Checked = false;
            x40ToolStripMenuItem.Checked = false;
            x50ToolStripMenuItem.Checked = false;
            x60ToolStripMenuItem.Checked = false;
            x70ToolStripMenuItem.Checked = false;
            x80ToolStripMenuItem.Checked = false;
            x90ToolStripMenuItem.Checked = false;
            x100ToolStripMenuItem.Checked = false;
            x200ToolStripMenuItem.Checked = false;
            x300ToolStripMenuItem.Checked = true;
            x400ToolStripMenuItem.Checked = false;
            x500ToolStripMenuItem.Checked = false;
            setBoxSize();
        }

        private void wrapGridToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (wrapGridToolStripMenuItem.Checked == true)
            {
                wrapGridToolStripMenuItem.Checked = false;
                gridWrap = false;
            }
            else
            {
                wrapGridToolStripMenuItem.Checked = true;
                gridWrap = true;
            }
        }

        private void x400ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            gridHeight = 400;
            gridWidth = 400;
            clearGrid();
            gridBox.Refresh();
            toolStripStatusLabel2.Text = "Grid Size: 400 x 400";
            x10ToolStripMenuItem.Checked = false;
            x20ToolStripMenuItem.Checked = false;
            x30ToolStripMenuItem.Checked = false;
            x40ToolStripMenuItem.Checked = false;
            x50ToolStripMenuItem.Checked = false;
            x60ToolStripMenuItem.Checked = false;
            x70ToolStripMenuItem.Checked = false;
            x80ToolStripMenuItem.Checked = false;
            x90ToolStripMenuItem.Checked = false;
            x100ToolStripMenuItem.Checked = false;
            x200ToolStripMenuItem.Checked = false;
            x300ToolStripMenuItem.Checked = false;
            x400ToolStripMenuItem.Checked = true;
            x500ToolStripMenuItem.Checked = false;
            setBoxSize();
        }

        private void x500ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            gridHeight = 500;
            gridWidth = 500;
            clearGrid();
            setBoxSize();
            gridBox.Refresh();
            toolStripStatusLabel2.Text = "Grid Size: 500 x 500";
            x10ToolStripMenuItem.Checked = false;
            x20ToolStripMenuItem.Checked = false;
            x30ToolStripMenuItem.Checked = false;
            x40ToolStripMenuItem.Checked = false;
            x50ToolStripMenuItem.Checked = false;
            x60ToolStripMenuItem.Checked = false;
            x70ToolStripMenuItem.Checked = false;
            x80ToolStripMenuItem.Checked = false;
            x90ToolStripMenuItem.Checked = false;
            x100ToolStripMenuItem.Checked = false;
            x200ToolStripMenuItem.Checked = false;
            x300ToolStripMenuItem.Checked = false;
            x400ToolStripMenuItem.Checked = false;
            x500ToolStripMenuItem.Checked = true;
        }

        private void fullScreenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (fullScreenToolStripMenuItem.Checked == true)
            {
                fullScreenToolStripMenuItem.Checked = false;
                this.TopMost = false;
                this.FormBorderStyle = FormBorderStyle.Sizable;
                this.Width = formWidth;
                this.Height = formHeight;
                this.Top = formTop;
                this.Left = formLeft;
            }
            else
            {
                formWidth = this.Width;
                formHeight = this.Height;
                formTop = this.Top;
                formLeft = this.Left;
                fullScreenToolStripMenuItem.Checked = true;
                this.FormBorderStyle = FormBorderStyle.None;
                this.Width = Screen.PrimaryScreen.Bounds.Width;
                this.Height = Screen.PrimaryScreen.Bounds.Height;
                this.Top = Screen.PrimaryScreen.Bounds.Top;
                this.Left = Screen.PrimaryScreen.Bounds.Left;
                this.TopMost = true;
                
                
            }
        }
        
        private void setBoxSize()
        {
            int cellWidth = panel2.Width / gridWidth;
            int cellHeight = panel2.Height / gridHeight;

            if (cellWidth == 0)
            {
                cellWidth = 1;
            }
            if (cellHeight == 0)
            {
                cellHeight = 1;
            }

            gridBox.Width = cellWidth * gridWidth + 1;
            gridBox.Height = cellHeight * gridHeight + 1;

            if (cellHeight > 1 && cellWidth > 1)
            {
                toolStripMenuItem2.Enabled = true;
            }
            else
            {
                toolStripMenuItem2.Enabled = false;
                toolStripMenuItem2.Checked = false;
                drawGrid = false;
            }
        }

        private void statsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            if (statsbox.Visible != true)
            {
                statsbox = new StatsBox();
                statsbox.Show();
            }
        }

    }
}
